/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sessions;

import java.util.ArrayList;
import java.util.Collection;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import entities.Client;
import entities.CompteBancaire;
import entities.CompteCourant;
import entities.CompteEpargne;
import entities.OperationBancaire;


/**
 *
 * @author ediltondossantos
 */
@Stateless
public class GestionnaireDeClient {

    GestionnaireDeCompteBancaire gestionnaireDeCompte;
    // Add business logic below. (Right-click in editor and choose
    // "Insert Code > Add Business Method")
    @PersistenceContext
    private EntityManager em;
    private Collection<Client> clients;
    private Collection<CompteBancaire> comptes;

    
    public void creerClientsTest() {
        CompteBancaire compte = new CompteBancaire();
        Client client = new Client();
        String[] nom = {"Delarue", "Delpierot", "Paris", "Delavega", "Sanpedro", "Dos Santos", "Ndao", "Masse", "Arlequin", "Mayolino", "Polidori", "Garcia", "Blanc", "Serra", "Guisset", "Martinez", "Mas"};
        String[] prenom = {"Marc", "Jean", "Sebastien", "Remy", "Greg", "Eddy", "Oumare", "Jacques", "Alain", "Marc", "Jean", "Sebastien", "Remy", "Greg", "Eddy", "Oumare", "Jacques"};
        String[] adresse = {"avenue du Châtaignier 06600 Antibes", "11 avenue des Alpes 06800 Cagnes-sur-Mer", "43 chemin du Pain-de-Sucre 06800 Cagnes-sur-Mer", "24 boulevard d'Oxford 06400 Cannes", "28 avenue Saint-Nicolas 06400 Cannes", "avenue du Châtaignier 06600 Antibes", "11 avenue des Alpes 06800 Cagnes-sur-Mer", "43 chemin du Pain-de-Sucre 06800 Cagnes-sur-Mer", "24 boulevard d'Oxford 06400 Cannes", "28 avenue Saint-Nicolas 06400 Cannes", "avenue du Châtaignier 06600 Antibes", "11 avenue des Alpes 06800 Cagnes-sur-Mer", "43 chemin du Pain-de-Sucre 06800 Cagnes-sur-Mer", "24 boulevard d'Oxford 06400 Cannes", "28 avenue Saint-Nicolas 06400 Cannes", "24 boulevard d'Oxford 06400 Cannes", "28 avenue Saint-Nicolas 06400 Cannes"};
        String[] telephone = {"0497212992", "0493206976", "0493737041", "0493684052", "0493383357", "0493064800", "0497212992", "0493206976", "0493737041", "0493684052", "0493383357", "0493064800", "0497212992", "0493206976", "0493737041", "0493684052", "0493383357"};

        for (int i = 0; i < nom.length; i++) {
            client = new Client(nom[i], prenom[i], adresse[i], telephone[i]);
            comptes = new ArrayList();
            if ((i % 2) == 0) {
                compte = new CompteEpargne("epargne", i * 2 * 1000);
                compte.setClient(client);
                OperationBancaire op = new OperationBancaire("Cration du compte", (int) compte.getSolde());
                compte.getOperations().add(op);
                comptes.add(compte);
                em.persist(compte);
            }
            compte = new CompteCourant("courant", i * 1000);
            compte.setClient(client);
            OperationBancaire op = new OperationBancaire("Cration du compte", (int) compte.getSolde());
            compte.getOperations().add(op);
            comptes.add(compte);
            em.persist(compte);
            client.setComptesBancaires(comptes);

            this.miseAJour(client);
        }

    }

    
    public Client creerClient(String nom, String prenom, String adresse, String telephone) {
        Client c = new Client(nom, prenom, adresse, telephone);
        em.persist(c);
        return c;
    }

    
    public Client miseAJour(Client c) {
        em.persist(c);
        return c;
    }

    
    public Collection<Client> afficherTout(int page) {
        Query q = em.createQuery("select c FROM Client c order by c.nom,c.prenom");
        page -= 1;
        page *= 10;
        q.setFirstResult(page);
        q.setMaxResults(10);
        return q.getResultList();
    }

    
    public Client getClient(int id) {
        return em.find(Client.class, id);
    }

    
    public void supprimer(int id) {
        em.remove(this.getClient(id));
    }

    
    public Collection<Client> getClientByNP(String str2, int page) {
        Query q = em.createQuery("Select c FROM Client c Where lower(c.nom)=?1 or lower(c.prenom)=?1").setParameter(1, str2.toLowerCase());
        page -= 1;
        page *= 10;
        q.setFirstResult(page);
        q.setMaxResults(10);
        return q.getResultList();
    }

    
    public CompteBancaire getCompte(int id) {
        return em.find(CompteBancaire.class, id);
    }

    
    public void ajouterNouveauCompte(int id, CompteBancaire compte) {
        compte.setClient(this.getClient(id));
        OperationBancaire op = new OperationBancaire("Cration du compte", (int) compte.getSolde());
        compte.getOperations().add(op);
        this.getClient(id).addCompteBancaire(compte);
        em.persist(compte);
    }
}
