/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sessions;

import java.util.Collection;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import entities.CompteBancaire;
import entities.OperationBancaire;


/**
 *
 * @author ediltondossantos
 */
@Stateless
public class GestionnaireDeCompteBancaire  {

    // Add business logic below. (Right-click in editor and choose
    // "Insert Code > Add Business Method")
    @PersistenceContext
     private EntityManager em;
    private Collection<CompteBancaire> compteBancaire;

    
    public void creerComptesTest(){
    creerCompteBancaire("John",1000);
    creerCompteBancaire("Paul",2000);
    creerCompteBancaire("Georges",3000);
    creerCompteBancaire("Ringo",4000);
    }
    
    public CompteBancaire creerCompteBancaire(String type,int solde){
         CompteBancaire c = new CompteBancaire(type,solde);
         OperationBancaire op=new OperationBancaire("Création du compte",solde);
         c.getOperations().add(op);
         em.persist(c);
         return c;
     }
    public CompteBancaire creerCompteBancaire(CompteBancaire c){
         OperationBancaire op=new OperationBancaire("Création du compte", (int) c.getSolde());
         c.getOperations().add(op);
         em.persist(c);
         return c;
     }

    
    public Collection<CompteBancaire> afficherTout(int page) {
        Query q=em.createQuery("select b FROM CompteBancaire b order by b.client.nom,b.client.prenom");
        page-=1;
    page*=10;
    q.setFirstResult(page);
    q.setMaxResults(10);
        compteBancaire =q.getResultList();
        return compteBancaire;
    }
    
    public Collection<CompteBancaire> afficherCompteCourant(int page) {
        Query q=em.createQuery("select b FROM CompteCourant b order by b.client.nom,b.client.prenom");
        page-=1;
    page*=10;
    q.setFirstResult(page);
    q.setMaxResults(10);
        compteBancaire =q.getResultList();
        return compteBancaire;
    }
    
    public Collection<CompteBancaire> afficherCompteEpargne(int page) {
        Query q=em.createQuery("select b FROM CompteEpargne b order by b.client.nom,b.client.prenom");
        page-=1;
    page*=10;
    q.setFirstResult(page);
    q.setMaxResults(10);
        compteBancaire =q.getResultList();
        return compteBancaire;
    }

    
    public String transfert(int idDonneur, int idReceveur,int montant){
        CompteBancaire ct1=em.find(CompteBancaire.class, idDonneur);
        CompteBancaire ct2=em.find(CompteBancaire.class, idReceveur);
        OperationBancaire debit=new OperationBancaire("Débit",-montant);
        OperationBancaire credit=new OperationBancaire("Crédit",montant);
        if(ct1.getSolde()>=montant){
            ct1.retirer(montant);
            ct1.addOperations(debit);
            ct2.deposer(montant);
            ct2.addOperations(credit);
            return "Transfert effectué nouveau solde du donneur= " + ct1.getSolde();
        }
        return "Provision insuffisante";
    }

    
    public CompteBancaire getCompte(int id) {
        return em.find(CompteBancaire.class, id);
    }
    
    public void supprimer(int id) {
        em.remove(this.getCompte(id));
    }
    
    public Collection<OperationBancaire> getOperation(int id, int page) {
        CompteBancaire compte=this.getCompte(id);
        Query q=em.createQuery("Select c.operations FROM CompteBancaire c Where c.id=?1").setParameter(1, id);
     page-=1;
    page*=10;
    q.setFirstResult(page);
    q.setMaxResults(10);
        return q.getResultList();
    }



}
